; Stars

InitStars       ld hl,StarTable                 ;
                ld (pFreeStars),hl              ;

                ld b,nStars                     ;

                ld de,lStar                     ;

ISlp            push hl                         ;
                pop ix                          ;

                add hl,de                       ;

                ld (ix+dpnStarFree),hl          ;

                djnz ISlp                       ;

                ld hl,0                         ;
                ld (ix+dpnStarFree),hl          ;
                ld (pStarList),hl               ;
                ld (pLastStar),hl               ;

                xor a                           ;
                ld (crStars),a                  ;

                ld a,nStars                     ;
                ld (cnStars),a                  ;

                ret                             ;

AddStar         ld hl,(pFreeStars)              ;

                ld a,l                          ;
                or h                            ;
                scf                             ;
                ret z                           ;

                ld ix,(pLastStar)               ;

                ld a,ixl                        ;
                or ixh                          ;
                jr nz,ASa                       ;

                ld (pStarList),hl               ;

ASa             ld (ix+dpnStar),hl              ;

                ld (pLastStar),hl               ;

                push hl                         ;
                pop ix                          ;

                ld hl,(ix+dpnStarFree)          ;
                ld (pFreeStars),hl              ;

                xor a                           ;
                ld (ix+dpnStar),a               ;
                ld (ix+dpnStar+1),a             ;

                ld a,(crStars)                  ;
                inc a                           ;
                ld (crStars),a                  ;

                or a                            ;
                ret                             ;

CreateStars     ld b,nStars                     ;

                ld hl,$500                      ;

SUSlp           push bc                         ;

                push hl                         ;
                call AddStar                    ;
                pop hl                          ;

                ld (ix+dStarZ),hl               ;

                ld de,$7000/nStars              ;
                add hl,de                       ;

                call Rand                       ;
                ld (ix+dStarX),de               ;

                ld de,StartY                    ;
                ld (ix+dStarY),de               ;

                ld (ix+dStarBit),0              ;
                ld (ix+dStarFlag),1             ;

                pop bc                          ;

                djnz SUSlp                      ;

                ret                             ;

ShowStars       call InitVectAdd                ;

                call ResMargin                  ;

                ld hl,WindowTable               ;
                ld (pcWindowLocal),hl           ;

                ld hl,(WindowTable)             ;
                ld (cWindZ),hl                  ;

                ld hl,0                         ;
                ld (pPrevStar),hl               ;

                ld hl,(pStarList)               ;

SSlp            ld a,l                          ;
                or h                            ;
                jp z,ReplaceStars               ;

                push hl                         ;
                pop ix                          ;

                ld de,dStarX                    ;
                add hl,de                       ;

                call DoVectAdd                  ;

SS0             ld hl,(ix+dStarZ)               ;
                ld de,(cWindZ)                  ;

                or a                            ;
                sbc hl,de                       ;

                jp m,SS1                        ;

                push ix                         ;

                ld ix,(pcWindowLocal)           ;

                ld hl,(ix+dWindL)               ; Changed!
                call SetLMargin                 ;

                ld hl,(ix+dWindR)               ;
                call SetRMargin                 ;

                ld hl,(ix+dWindU)               ;
                call SetUMargin                 ;

                ld hl,(ix+dWindD)               ;
                call SetDMargin                 ;

                ld de,lWind                     ;
                add ix,de                       ;

                ld (pcWindowLocal),ix           ;

                ld hl,(ix+dpnStar)              ;

                ld (cWindZ),hl                  ;

                pop ix                          ;

                jp SS0                          ;

SS1             bit 7,(ix+dStarZ+1)             ;
                jp nz,SSn                       ;

                ld hl,(ix+dStarX)               ;

                ld de,(ix+dStarZ)               ;

                bit 7,h                         ;
                jr nz,SSW1                      ;

                or a                            ;
                sbc hl,de                       ;
                jp nc,SSn                       ;

                add hl,de                       ;

                call DivHLDE                    ;

                srl h                           ;
                rr l                            ;

                jp SS2                          ;

SSW1            Neg_HL()                        ;

                or a                            ;
                sbc hl,de                       ;
                jp nc,SSn                       ;

                add hl,de                       ;
                call DivHLDE                    ;

                srl h                           ;
                rr l                            ;

                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                ld h,$FF                        ;
                inc hl                          ;

SS2             push hl                         ;

                ld hl,(ix+dStarY)               ;

                ld de,(ix+dStarZ)               ;

                bit 7,h                         ;
                jr nz,SSW1a                     ;

                or a                            ;
                sbc hl,de                       ;
                jp nc,SSna                      ;

                add hl,de                       ;

                call DivHLDE                    ;

                srl h                           ;
                rr l                            ;

                jp SS2a                         ;

SSW1a           Neg_HL()                        ;

                or a                            ;
                sbc hl,de                       ;
                jp nc,SSna                      ;

                add hl,de                       ;

                call DivHLDE                    ;

                srl h                           ;
                rr l                            ;

                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                ld h,$FF                        ;
                inc hl                          ;

SS2a            pop de                          ;

                call ClipAddr                   ;

                ld de,(ix+dStarAddr)            ;
                ld b,(ix+dStarBit)              ;

                ld (ix+dStarAddr),hl            ;
                ld (ix+dStarBit),a              ;

                ld c,a                          ;

                ex de,hl                        ;
                ld a,b                          ;
                cpl                             ;
                and (hl)                        ;
                ld (hl),a                       ;
                ex de,hl                        ;

                ld a,c                          ;
                and (hl)                        ;
                jr nz,SS3                       ;

                ld a,c                          ;
                or (hl)                         ;

                ld (hl),a                       ;

SS3             ld (pPrevStar),ix               ;

                ld hl,(ix+dpnStar)              ;

                jp SSlp                         ;

SSna            pop hl                          ;

SSn             ld iy,(pPrevStar)               ;

                ld hl,(ix+dStarAddr)            ; Swapped accesses
                ld a,(ix+dStarBit)              ;

                cpl                             ;
                and (hl)                        ;
                ld (hl),a                       ;

                ld a,(crStars)                  ;
                dec a                           ;
                ld (crStars),a                  ;

                push ix                         ;
                pop hl                          ;
                ld de,(pLastStar)               ;
                or a                            ;
                sbc hl,de                       ;
                jr nz,SSnc                      ;

                ld (pLastStar),iy               ;

SSnc            ld hl,(ix+dpnStar)              ;
                ld (iy+dpnStar),hl              ;

                ld a,iyl                        ;
                or iyh                          ;
                jr nz,SSnb                      ;

                ld (pStarList),hl               ;

SSnb            ld hl,(pFreeStars)              ;
                ld (ix+dpnStarFree),hl          ;

                ld (pFreeStars),ix              ;

                ld hl,(ix+dpnStar)              ;

                jp SSlp                         ;

ReplaceStars    ld a,(cnStars)                  ;
                ld b,a                          ;
                ld a,(crStars)                  ;

                sub b                           ;
                ret nc                          ;

                call AddStar                    ;
                ret c                           ;

                ld hl,$7F00                     ;
                ld (ix+dStarZ),hl               ;

                call Rand                       ;
                ld (ix+dStarX),de               ;

                ld hl,(GroundY)                 ;
                ld (ix+dStarY),hl               ;

                ld (ix+dStarBit),0              ;

                ld (ix+dStarFlag),1             ;

                ret                             ;

pFreeStars      defs 2                          ;
pStarList       defs 2                          ;
pLastStar       defs 2                          ;
pPrevStar       defs 2                          ;

crStars         defs 1                          ;

pcWindowLocal   defs 2                          ;
cWindZ          defs 2                          ;

;  Spurious pop ix

		; For some reason there's a spurious pop ix here in the original source
		; an editing mistake? A joke? Misdirection? Who knows...
	if def Original
                pop ix                          ;
		noflow				;
	endif

; End of stars
