; Start of stats

DoRhino         ld a,(DDamage)                  ;
                ld (RhinoDamage),a              ;

                ld a,DamFSD                     ;
                ld (DDamage),a                  ;

                ld hl,(DScore)                  ;
                ld (RhinoScore),hl              ;

                ld hl,0                         ;
                ld (DScore),hl                  ;

                ld hl,Ret0                      ;
                ld (cFlashRoutine),hl           ;

                ld hl,sRhino                    ;
                call vAddScroll                 ;

                halt                            ;
                halt                            ;

PlayRhino       xor a                           ;
                ld (nRhinos),a                  ;

RhinoPlay       call CLS                        ;

                call RhinoInc                   ;

                call RhinoInit                  ;

                call RhinoDisp                  ;

RhinoLoop       call RhinoManMove               ;

                call MoveRhino                  ;

                ld b,200                        ;
                djnz $                          ;

                ld a,(RhinoEnd)                 ;
                cp 1                            ;
                jr z,RhinoFini                  ;

                ld a,(ADamage)                  ;
                or a                            ;
                jr nz,RhinoLoop                 ;

                ld hl,sRhino1                   ;
                call vAddScroll                 ;

                ld b,170                        ;

Rlx             halt                            ;
                djnz Rlx                        ;

                ld hl,(RhinoScore)              ;
                ld (DScore),hl                  ;

                ld a,(RhinoDamage)              ;
                ld (DDamage),a                  ;

                ret                             ;

RhinoFini       ld a,$10                        ;
                call AddScore                   ;

                ld b,20                         ;
                call AlwaysDoDamage             ;

                jp RhinoPlay                    ;

RhinoClear      push hl                         ;

                call RhinoMUp                   ;
                ld (hl),1                       ;

                call RhinoMRight                ;
                ld (hl),1                       ;

                call RhinoMDown                 ;
                ld (hl),1                       ;

                call RhinoMDown                 ;
                ld (hl),1                       ;

                call RhinoMLeft                 ;
                ld (hl),1                       ;

                call RhinoMLeft                 ;
                ld (hl),1                       ;

                call RhinoMUp                   ;
                ld (hl),1                       ;

                call RhinoMUp                   ;
                ld (hl),1                       ;

                pop hl                          ;
                ret                             ;

RhinoInc        ld a,(nRhinos)                  ;
                inc a                           ;
                cp 16                           ;
                ret z                           ;
                ld (nRhinos),a                  ;
                ret                             ;

RhinoGetPos     push de                         ;

                call Rand                       ;

                ld a,e                          ;
                pop de                          ;

                ld l,a                          ;
                ld h,RhinoMap / 256             ;

                ld a,(hl)                       ;
                or a                            ;
                jr nz,RhinoGetPos               ;

                ret                             ;

RhinoInit       ld hl,RhinoMap                  ;
                ld b,0                          ;
                xor a                           ;
                ld (RhinoEnd),a                 ;

RIlp            ld (hl),a                       ;
                inc hl                          ;

                djnz RIlp                       ;

                ld hl,RhinoMap+$11              ;
                call RhinoClear                 ;
                ld (RhinoManPos),hl             ;

                ld a,cRhinoMan                  ;
                ld (hl),a                       ;
                call RhinoPrint                 ;

                ld hl,RhinoMap+$EE              ;
                call RhinoClear                 ;

                ld a,cRhinoExit                 ;
                ld (hl),a                       ;
                call RhinoPrint                 ;

                ld b,20                         ;

RIlp1           call RhinoGetPos                ;

                ld (hl),cRhinoTree              ;

                djnz RIlp1                      ;

                ld a,(nRhinos)                  ;
                ld b,a                          ;

                ld ix,RhinoList                 ;

RIlp2           push bc                         ;

                call RhinoGetPos                ;

                ld (hl),cRhinoTree              ;

                ld (ix+dRhinoPos),hl            ;

                ld a,r                          ;
                and $7F                         ;
                add a,65                        ;
                ld (ix+dRhinoiSpeed),a          ;
                ld (ix+dRhinoSpeed),1           ;
                ld (ix+dRhinoFlag),0            ;

                ld bc,lRhino                    ;
                add ix,bc                       ;

                pop bc                          ;

                djnz RIlp2                      ;

                ld b,4                          ;

RIlp5           call RhinoGetPos                ;

                ld (hl),cRhinoFuel              ;

                djnz RIlp5                      ;

                ld hl,RhinoMap                  ;

RIlp3           ld a,(hl)                       ;
                dec a                           ;
                jr nz,RIlp3a                    ;
                ld (hl),a                       ;

RIlp3a          inc l                           ;
                jr nz,RIlp3                     ;

                ret                             ;

MoveRhino       ld a,(nRhinos)                  ;
                ld b,a                          ;
                ld ix,RhinoList                 ;

MRlp            push bc                         ;

                dec (ix+dRhinoSpeed)            ;
                jr nz,MR3                       ;

                ld a,(ix+dRhinoiSpeed)          ;
                ld (ix+dRhinoSpeed),a           ;

MR1             ld a,(ix+dRhinoFlag)            ;
                or a                            ;
                jr nz,MR2                       ;

                ld hl,(ix+dRhinoPos)            ;

                call RhinoVector                ;
                call RhinoLook                  ;
                jr nc,MR3                       ;

MR2             ld (ix+dRhinoFlag),1            ;

                ld hl,(ix+dRhinoPos)            ;

                call RhinoVector                ;

                call VectorAdd                  ;

                ld a,(hl)                       ;
                or a                            ;
                jr nz,MR3a                      ;

MR3c            ex de,hl                        ;
                ld hl,(ix+dRhinoPos)            ;
                ld a,(hl)                       ;
                cp cRhinoChar                   ;
                jr nz,MR2b                      ;

                xor a                           ;
                ld (hl),a                       ;
                call RhinoPrint                 ;

MR2b            ex de,hl                        ;
                ld a,cRhinoChar                 ;
                ld (hl),a                       ;
                call RhinoPrint                 ;

                ld (ix+dRhinoPos),hl            ;

MR3             ld bc,lRhino                    ;
                add ix,bc                       ;

                pop bc                          ;

                djnz MRlp                       ;

                ret                             ;

MR3a            cp cRhinoFuel                   ;
                jr nz,MR3b                      ;

                sra (ix+dRhinoiSpeed)           ;

                jr MR3c                         ;

MR3b            cp cRhinoMan                    ;
                jr nz,MR3                       ;

                call RhinoHit                   ;

                jr MR3                          ;

RhinoVector     ld a,l                          ;
                and $0F                         ;
                ld e,a                          ;

                ld a,(RhinoManPos)              ;
                and $0F                         ;

                sub e                           ;

                ld d,0                          ;
                jr z,RVa                        ;

                ld d,$01                        ;
                jp p,RVa                        ;

                ld d,$02                        ;

RVa             ld a,l                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $0F                         ;
                ld e,a                          ;

                ld a,(RhinoManPos)              ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $0F                         ;
                sub e                           ;

                ret z                           ;

                set 2,d                         ;
                ret p                           ;

                ld a,d                          ;
                xor $0C                         ;
                ld d,a                          ;
                ret                             ;

VectorAdd       bit 0,d                         ;
                call nz,RhinoMRight             ;

                bit 1,d                         ;
                call nz,RhinoMLeft              ;

                bit 2,d                         ;
                call nz,RhinoMDown              ;

                bit 3,d                         ;
                call nz,RhinoMUp                ;

                ret                             ;

RhinoLook       ld b,h                          ;
                ld c,l                          ;

                call VectorAdd                  ;

                or a                            ;
                sbc hl,bc                       ;
                add hl,bc                       ;
                scf                             ;
                ccf                             ;
                ret z                           ;

                ld a,(hl)                       ;
                or a                            ;
                jr z,RhinoLook                  ;

                cp cRhinoMan                    ;
                scf                             ;
                ret z                           ;

                cp cRhinoTree                   ;
                jr nz,RhinoLook                 ;

                or a                            ;
                ret                             ;

RhinoDisp       ld hl,RhinoMap                  ;
                ld b,0                          ;

RDlp            ld a,(hl)                       ;
                call RhinoPrint                 ;

                inc hl                          ;

                djnz RDlp                       ;

                ret                             ;

RhinoPrint      push de                         ;
                push bc                         ;
                push af                         ;

                ld a,l                          ;
                and $0F                         ;
                ld e,a                          ;

                ld a,l                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $0F                         ;
                ld d,a                          ;

                pop af                          ;

                or a                            ;
                jr z,RPa                        ;

                call PrintMap                   ;

                pop bc                          ;
                pop de                          ;
                ret                             ;

RPa             ld a,cRhinoBlank                ;
                call PrintMap                   ;

                pop bc                          ;
                pop de                          ;
                ret                             ;

RhinoManMove    ld hl,RhinoManSpeed             ;
                dec (hl)                        ;
                ret nz                          ;

                ld (hl),30                      ;

                ld hl,(RhinoManPos)             ;

                call kLeft                      ;
                call nz,RhinoMLeft              ;

                call kRight                     ;
                call nz,RhinoMRight             ;

                call kUp                        ;
                call nz,RhinoMUp                ;

                call kDown                      ;
                call nz,RhinoMDown              ;

                ld a,(hl)                       ;
                or a                            ;
                jr z,RMMa                       ;

                cp cRhinoExit                   ;
                jr nz,RMMb                      ;

                ld a,1                          ;
                ld (RhinoEnd),a                 ;

RMMa            ex de,hl                        ;
                ld hl,(RhinoManPos)             ;

                xor a                           ;
                ld (hl),a                       ;
                call RhinoPrint                 ;

                ex de,hl                        ;
                ld a,cRhinoMan                  ;
                ld (hl),a                       ;
                call RhinoPrint                 ;

                ld (RhinoManPos),hl             ;
                ret                             ;

RMMb            cp cRhinoFuel                   ;
                jr nz,RMMc                      ;

                push hl                         ;

                ld b,20                         ;
                call AlwaysDoDamage             ;

                ld a,1                          ;
                call AddScore                   ;

                pop hl                          ;

                jr RMMa                         ;

RMMc            cp cRhinoChar                   ;
                ret nz                          ;

RhinoHit        ld b,-1                         ;
                jp AlwaysDoDamage               ;

RhinoEnd        defs 1                          ;
RhinoManPos     defs 2                          ;
RhinoManSpeed   defs 1                          ;
nRhinos         defs 1                          ;
RhinoDamage     defs 1                          ;
RhinoScore      defs 2                          ;

RhinoMLeft      dec hl                          ;
                ld a,l                          ;
                cpl                             ;
                and $0F                         ;
                ret nz                          ;
                inc hl                          ;
                ret                             ;

RhinoMRight     inc hl                          ;
                ld a,l                          ;
                and $0F                         ;
                ret nz                          ;
                dec hl                          ;
                ret                             ;

RhinoMUp        ld e,-16                        ;
                ld a,l                          ;
                add a,e                         ;
                ld l,a                          ;
                cpl                             ;
                and $F0                         ;
                ret nz                          ;
                ld a,l                          ;
                sub e                           ;
                ld l,a                          ;
                ret                             ;

RhinoMDown      ld e,16                         ;
                ld a,l                          ;
                add a,e                         ;
                ld l,a                          ;
                and $F0                         ;
                ret nz                          ;
                ld a,l                          ;
                sub e                           ;
                ld l,a                          ;
                ret                             ;

InitStats       ld hl,$FFFF                     ;
                ld (CurrentStat),hl             ;

                ld hl,Ret0                      ;
                ld (cFlashRoutine),hl           ;

                ret                             ;

DispStatsInner  ld bc,$F7FE                     ;
                in a,(c)                        ;
                bit 3,a                         ;
                jr nz,DS1                       ;

StatsExit       ld hl,$FFFF                     ;
                ld (CurrentStat),hl             ;

                ld hl,Ret0                      ;
                ld (cFlashRoutine),hl           ;

                jp CLS                          ;

DS1             or $F8                          ;
                inc a                           ;
                jr nz,DispStats                 ;

                ld hl,0                         ;
cFlashValue     equ .-2                         ;

                dec hl                          ;
                ld (cFlashValue),hl             ;

                ld a,h                          ;
                or l                            ;

                call z,0                        ;
cFlashRoutine   equ .-2                         ;

                ld b,0                          ;
                djnz $                          ;

                jp DispStatsInner               ;

DispStats       dec a                           ;
                cpl                             ;
                and $07                         ;
                add a,a                         ;
                add a,pStats & $FF            ;
                ld l,a                          ;
                ld a,pStats / 256               ;
                adc a,0                         ;
                ld h,a                          ;

                ld a,(hl)                       ;
                inc hl                          ;
                ld h,(hl)                       ;
                ld l,a                          ;

                ; Has the display routine changed?

                ld de,(CurrentStat)             ;
                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                ld (CurrentStat),hl             ;

                call nz,CallHL                  ; If so, call it...

                jr DispStatsInner               ;

CurrentStat     defw $FFFF                      ;

pStats          defw DoMap                      ; Null
                defw DoMap                      ;
                defw DoOpt                      ;
                defw DoMap                      ;
                defw DoCode                     ;
                defw DoOpt                      ;
                defw DoCode                     ;
                defw DoRhino                    ;

SteppMapR       push bc                         ;
                push af                         ;

                ld a,l                          ;
                inc a                           ;
                and $1F                         ;
                ld c,a                          ;

                ld a,l                          ;
                and $E0                         ;
                or c                            ;
                ld l,a                          ;

                pop af                          ;
                pop bc                          ;
                ret                             ;


SteppMapL       push bc                         ;
                push af                         ;

                ld a,l                          ;
                dec a                           ;
                and $1F                         ;
                ld c,a                          ;

                ld a,l                          ;
                and $E0                         ;
                or c                            ;
                ld l,a                          ;

                pop af                          ;
                pop bc                          ;
                ret                             ;


SteppMapU       push bc                         ;
                push af                         ;

                ld a,l                          ;
                sub $20                         ;
                ld l,a                          ;

                jr nc,SpMU                      ;

                ld a,h                          ;
                cp Map / 256                    ;

                ld h,Map / 256                  ;

                jr nz,SpMU                      ;

                ld h,0+(Map+$100) / 256         ;

SpMU            pop af                          ;
                pop bc                          ;
                ret                             ;


SteppMapD       push bc                         ;
                push af                         ;

                ld a,l                          ;
                add a,$20                       ;
                ld l,a                          ;

                jr nc,SpMD                      ;

                ld a,h                          ;
                cp Map / 256                    ;

                ld h,Map / 256                  ;

                jr nz,SpMD                      ;

                ld h,0+(Map+$100) / 256         ;

SpMD            pop af                          ;
                pop bc                          ;
                ret                             ;


PrintMap        push hl                         ;
                push de                         ;
                push af                         ;

                ld a,d                          ;
                add a,MapoY                     ;
                add a,a                         ;
                add a,YTab & $FF              ;
                ld l,a                          ;

                ld a,YTab / 256                 ;
                adc a,0                         ;
                ld h,a                          ;

                ld a,(hl)                       ;
                inc hl                          ;
                ld h,(hl)                       ;
                ld l,a                          ;

                ld a,e                          ;
                add a,MapoX                     ;
                or l                            ;
                ld l,a                          ;

                pop af                          ;
                push af                         ;

                ld e,a                          ;

                add a,a                         ;
                add a,a                         ;
                add a,a                         ;
                add a,e                         ; *9

                add a,MapChars & $FF            ;
                ld e,a                          ;
                ld a,MapChars / 256             ;
                adc a,0                         ;
                ld d,a                          ;

                push hl                         ;

                ld a,h                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $03                         ;
                or $58                          ;
                ld h,a                          ;

                ld a,(de)                       ;
                inc de                          ;
                ld (hl),a                       ;

                pop hl                          ;

                ld b,8                          ;

MPlp            ld a,(de)                       ;
                ld (hl),a                       ;

                inc h                           ;
                inc de                          ;

                djnz MPlp                       ;

                pop af                          ;
                pop de                          ;
                pop hl                          ;
                ret                             ;

Print8x8        push hl                         ;
                push de                         ;
                push bc                         ;
                push af                         ;
                push hl                         ;

                ld l,a                          ;
                ld h,0                          ;
                ld d,h                          ;
                ld e,l                          ;

                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;
                add hl,de                       ;

                ld de,MapChars                  ;
                add hl,de                       ;

                ex de,hl                        ;

                pop hl                          ;

                push hl                         ;

                ld a,h                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $03                         ;
                or $58                          ;
                ld h,a                          ;

                ld a,(de)                       ;
                inc de                          ;
                ld (hl),a                       ;

                pop hl                          ;

                ld b,8                          ;

P8lp            ld a,(de)                       ;
                ld (hl),a                       ;

                inc h                           ;
                inc de                          ;

                djnz P8lp                       ;

                pop af                          ;
                pop bc                          ;
                pop de                          ;
                pop hl                          ;
                ret                             ;

ShowMap         ld hl,(pMap)                    ;

                ld b,7                          ;

OffsetL         call SteppMapL                  ;
                call SteppMapU                  ;

                djnz OffsetL                    ;

                ld d,0                          ;

SMlp1           ld e,0                          ;

                push hl                         ;

SMlp2           call GetMap                     ;

                call MapConvert                 ;

                call PrintMap                   ;

                call SteppMapR                  ;

                ld a,15                         ;

                inc e                           ;
                cp e                            ;
                jr nz,SMlp2                     ;

                pop hl                          ;

                call SteppMapD                  ;

                inc d                           ;
                cp d                            ;
                jr nz,SMlp1                     ;

                ld hl,(pMap)                    ;
                ld a,(hl)                       ;
                call MapConvert                 ;
                ld h,a                          ;

                ld a,(Angle)                    ;
                ld l,a                          ;

                ld (FlashChars),hl              ;

                ld hl,MapFlash                  ;
StartFlash      ld (cFlashRoutine),hl           ;

                ld hl,1                         ;
                ld (cFlashValue),hl             ;

                ret                             ;

MapFlash        ld hl,$F1F2                     ;
FlashChars      equ .-2                         ;

                ld a,h                          ;
                ld h,l                          ;
                ld l,a                          ;

                ld (FlashChars),hl              ;

                ld de,$0707                     ;
                call PrintMap                   ;

                ld hl,MapFlashRate              ;
                ld (cFlashValue),hl             ;

                ; If Fire and '5' we allow moving on the map

        if not def Original

                ; If Fire and '5' we allow moving on the map

                call kFire                      ; Fire?
                jr z MF_X                       ; No...

                ld bc,$F7FE                     ; '5'?
                in a,(c)                        ;
                bit 4,a                         ;
                jr nz MF_X                      ;


                call kUp                        ; Up?
                jr nz FC_Up                     ; Yes, skip

                call kDown                      ; Down
                jr nz FC_Down                   ; Yes, skip

                call kLeft                      ; Left?
                jr nz FC_Left                   ; Yes, skip

                call kRight                     ; Right?
                jr nz FC_Right                  ; Yes, skip

MF_X            ret                             ; Done

        ; Move UP

FC_Up           ld hl,(pMap)                    ;
                call SteppMapU                  ;
                ld (pMap),hl                    ;

                call DoMap                      ;

                call InitMapLocal               ;

                ret                             ;

        ; Move DOWN

FC_Down         ld hl,(pMap)                    ;
                call SteppMapD                  ;
                ld (pMap),hl                    ;

                call DoMap                      ;

                call InitMapLocal               ;

                ret                             ;

        ; Move LEFT

FC_Left         ld hl,(pMap)                    ;
                call SteppMapL                  ;
                ld (pMap),hl                    ;

                call DoMap                      ;

                call InitMapLocal               ;

                ret                             ;

        ; Move RIGHT

FC_Right        ld hl,(pMap)                    ;
                call SteppMapR                  ;
                ld (pMap),hl                    ;

                call DoMap                      ;

                call InitMapLocal               ;
        endif

                ret                             ;


GetMap          ld a,(hl)                       ;
                ret                             ;

MapConvert      cp $FA                          ;
                jr nc,MC1                       ;

                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $1F                         ;

                add a,8                         ;

                ret                             ;

MC1             push bc                         ;

                sub $FA                         ;
                add a,$0E                       ;

                pop bc                          ;
                ret                             ;

YTab            defw $4000,$4020,$4040,$4060    ;
                defw $4080,$40A0,$40C0,$40E0    ;
                defw $4800,$4820,$4840,$4860    ;
                defw $4880,$48A0,$48C0,$48E0    ;
                defw $5000,$5020,$5040,$5060    ;
                defw $5080,$50A0,$50C0,$50E0    ;

DoMap           call CLS                        ;

                ld hl,sMap                      ;
                call vPrintStr                  ;

                ld hl,MapKeyTable               ;

DMlp            ld a,(hl)                       ;
                or a                            ;
                jr z,DMa                        ;
                inc hl                          ;

                ld e,(hl)                       ;
                inc hl                          ;
                ld d,(hl)                       ;
                inc hl                          ;

                call MapConvert                 ;
                call PrintMap                   ;

                jr DMlp                         ;

DMa             jp ShowMap                      ;

MapKeyTable     defb $FE                        ;
                defw $04F0                      ;
                defb $FB                        ;
                defw $06F0                      ;

                defb $18                        ;
                defw $08F0                      ;
                defb $08                        ;
                defw $08F1                      ;
                defb $10                        ;
                defw $08F2                      ;

                defb $FC                        ;
                defw $0AF0                      ;

                defb $FF                        ;
                defw $0CF0                      ;

                defb $28                        ;
                defw $0EF0                      ;

                defb $FD                        ;
                defw $10F0                      ;

                defb 0                          ;

DoOpt           call CLS                        ;

                ld hl,sIFF                      ;
                call vPrintStr                  ;

                ld hl,OptFlash                  ;
                jp StartFlash                   ;


OptFlash        ld bc,$0020                     ;
                call vScanOptiKeys              ;
                jr nc,OFx                       ;

                ld a,GameQuit                   ;
                ld (EndState),a                 ;

                pop hl                          ;
                ret                             ;

OFx             ld hl,1                         ;
                ld (cFlashValue),hl             ;

                ret                             ;


DoCode          call CLS                        ;

                ld hl,sCode                     ;
                call vPrintStr                  ;

                ld d,1                          ;
                call DisplayCodes               ;

                ld hl,CodeFlash                 ;
                jp StartFlash                   ;

CodeFlash       ld hl,CodeFlashRate             ;
                ld (cFlashValue),hl             ;

                ld d,0                          ;
                jp DisplayCodes                 ;

DisplayCodes    ld a,2                          ;
                ld (ppCurY),a                   ;

                ld hl,Codes                     ;
                ld c,nCodes                     ;

DClp            ld a,cCret                      ;
                call vPrint                     ;

                ld a,CodesX                     ;
                ld (pCurX),a                    ;

                ld e,(hl)                       ;
                inc hl                          ;

                bit 0,d                         ;
                jr z,DCa                        ;

                bit 0,e                         ;
                call nz,PrintFound              ;
                call z,PrintNotFound            ;

DCa             ld a,e                          ;
                cpl                             ;
                or d                            ;
                bit 0,a                         ;
                jr nz,DCb                       ;

                inc hl                          ;
                inc hl                          ;
                inc hl                          ;
                inc hl                          ;

                jr DCc                          ;

DCb             ld a,5                          ;
                call vPrint                     ;

                ld b,4                          ;

                ld a,CodesXc                    ;
                ld (pCurX),a                    ;

DClpA           ld a,(pCurX)                    ;
                ld ixl,a                        ;

                ld a,(hl)                       ;

                bit 0,d                         ;
                call z,vPrint                   ;

                ld a,ixl                        ;
                ld (pCurX),a                    ;

                ld a,(hl)                       ;

                bit 0,e                         ;
                call z,RandomChar               ;

                ld (hl),a                       ;
                inc hl                          ;

                call vPrint                     ;

                ld a,ixl                        ;
                add a,6                         ;
                ld (pCurX),a                    ;

                djnz DClpA                      ;

DCc             dec c                           ;
                jr nz,DClp                      ;

                ret                             ;

PrintFound      push af                         ;
                push hl                         ;

                ld hl,sFound                    ;
                call vPrintStr                  ;

                pop hl                          ;
                pop af                          ;
                ret                             ;

PrintNotFound   push hl                         ;

                ld hl,sNotFound                 ;
                call vPrintStr                  ;

                pop hl                          ;
                ret                             ;

RandomChar      ld a,r                          ;
                and $0F                         ;
                add a,"0"                       ;
                cp "9"+1                        ;
                ret c                           ;
                add a,"A"-("9"+1)               ;
                ret                             ;

InitCodes       ld hl,Codes                     ;
                ld de,5                         ;
                ld b,nCodes                     ;
                xor a                           ;

IClp            ld (hl),a                       ;
                add hl,de                       ;

                djnz IClp                       ;

                ld (nCodesFound),a              ;

                ret                             ;

AddCodes        ld a,(nCodesFound)              ;
                cp nCodes                       ;
                jr z,AddC1                      ;

                inc a                           ;

AddC1           ld (nCodesFound),a              ;

                ld hl,(pMap)                    ;
                ld a,(hl)                       ;
                cp $FB                          ;
                jr nz,AddC2                     ;

                dec (hl)                        ;

AddC2           ld hl,InitialCodes              ;
                ld de,Codes                     ;
                ld bc,4                         ;

AClp            ld a,(de)                       ;
                or a                            ;
                jr z,ACadd                      ;

                inc de                          ;
                add hl,bc                       ;

                ex de,hl                        ;
                add hl,bc                       ;
                ex de,hl                        ;

                jr AClp                         ;

ACadd           inc a                           ;
                ld (de),a                       ;

                inc de                          ;

                push hl                         ;
                push bc                         ;

                ldir                            ;

                pop bc                          ;
                pop hl                          ;

                ld de,AddCodeStr                ;
                ldir                            ;

                push ix                         ;

                ld hl,sScrollCodes              ;
                call vAddScroll                 ;

                pop ix                          ;
                ret                             ;

sScrollCodes    defb $06,"Code sequence",$05
AddCodeStr      defb "%%%%",$06,"recieved",$00,$FF
sFound          defb $06,"Recieved -",$00
sNotFound       defb $03," ",$00
sRhino          defb $05,"Welcome to",$07,"Whino Hunt",$00,$FF
sRhino1         defb $04,"Wavaged by a wampant whino !",$00,$FF
sMap            defb $0E,$0D,$0D,$0D,$05,"Terrain within scope",$0D,$0D,$03
                defb "Key to display",$0D,$0D,$06,"     = Unknown",$0D,$0D,$03
                defb "     = Code Stores",$0D,$0D,$06,"     = Plasma Guides",$0D,$0D,$03
                defb "     = Dislocations",$0D,$0D,$04,"     = Heavy Defences",$0D,$0D,$05
                defb "     = Energy Stores",$0D,$0D,$07,"     = Exit Linear Accele"
                defb "rator",$00
sCode           defb $0E,$0D,$0D,$0D,$05,"Escape Code Sequence",$0D,$00
sIFF            defb $0E,$0D,$0D,$0D,$05,"Various Options",$0D,$0D,$0D,$06
                defb "Press ",$07,"ENTER ",$06,"to quit game .",$0D,$0D,$05
                defb "Press ",$07,"4 ",$05,"to continue .",$00

MapChars        defb $05                        ;
                defb $10,$38,$54,$10,$10,$10,$10,$10;

                defb $05                        ;
                defb $07,$03,$05,$08,$10,$20,$40,$80;

                defb $05                        ;
                defb $00,$04,$02,$FF,$02,$04,$00,$00;

                defb $05                        ;
                defb $80,$40,$20,$10,$08,$05,$03,$07;

                defb $05                        ;
                defb $10,$10,$10,$10,$10,$54,$38,$10;

                defb $05                        ;
                defb $01,$02,$04,$08,$10,$A0,$C0,$E0;

                defb $05                        ;
                defb $00,$20,$40,$FF,$40,$20,$00,$00;

                defb $05                        ;
                defb $E0,$C0,$A0,$10,$08,$04,$02,$01;

                defb $06                        ;
                defb $00,$00,$00,$00,$00,$00,$00,$00;

                defb $06                        ;
                defb $00,$00,$3C,$00,$00,$3C,$00,$00;

                defb $06                        ;
                defb $00,$02,$42,$E2,$47,$42,$40,$00;

                defb $06                        ;
                defb $00,$40,$42,$47,$E2,$42,$02,$00;

                defb $43                        ;
                defb $00,$28,$10,$28,$10,$10,$10,$10;

                defb $45                        ;
                defb $00,$3C,$20,$38,$20,$20,$20,$00;

                defb $07                        ;
                defb $28,$00,$AA,$00,$AA,$00,$28,$00;

                defb $07                        ;
                defb $00,$28,$AA,$AA,$AA,$AA,$28,$00;

                defb $04                        ;
                defb $00,$6E,$89,$69,$19,$19,$6E,$00;

                defb $47                        ;
                defb $10,$54,$38,$EE,$38,$54,$10,$00;

                defb $43                        ;
                defb $00,$00,$00,$00,$00,$00,$00,$00;

                defb $44                        ;
                defb $28,$54,$AA,$55,$AA,$55,$2A,$14;

                defb $44                        ;
                defb $00,$00,$00,$00,$00,$00,$00,$00;

                defb $45                        ;
                defb $00,$00,$18,$3C,$3C,$18,$00,$00;

                defb $05                        ;
                defb $00,$18,$24,$42,$42,$24,$18,$00;

                defb $43                        ;
                defb $00,$00,$02,$7C,$A4,$24,$24,$00;

	; These are the codes that are displayed.
	;
	; I've forgotten how these are used to find the secret code :(
        ;

InitialCodes    defb "9472"                     ;
                defb "E602"                     ;
                defb "F627"                     ;
                defb "0227"                     ;
                defb "6756"                     ;
                defb "9647"                     ;
                defb "5602"                     ;
                defb "5726"                     ;
                defb "0237"                     ;
                defb "0226"                     ;
                defb "9647"                     ;
                defb "2696"                     ;
                defb "5656"                     ;
                defb "5666"                     ;
                defb "7237"                     ;
                defb "3786"                     ;

Codes           defs 5 * 16                     ;

;  End of STATS

